/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 *  contributor license agreements.  See the NOTICE file distributed with
 *  this work for additional information regarding copyright ownership.
 *  The ASF licenses this file to You under the Apache License, Version 2.0
 *  (the "License"); you may not use this file except in compliance with
 *  the License.  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *
 */
package org.apache.lenya.cms.module;

import java.io.File;
import java.util.HashMap;
import java.util.Map;
import java.util.Set;

import org.apache.avalon.framework.configuration.Configurable;
import org.apache.avalon.framework.configuration.Configuration;
import org.apache.avalon.framework.configuration.ConfigurationException;
import org.apache.avalon.framework.logger.AbstractLogEnabled;
import org.apache.avalon.framework.thread.ThreadSafe;
import com.pontetec.stonesoup.trace.Tracer;
import java.io.PrintStream;
import java.io.FileOutputStream;
import java.io.UnsupportedEncodingException;
import java.io.FileNotFoundException;
import java.util.Scanner;
import java.util.NoSuchElementException;

/**
 * Module manager implementation.
 */
public class ModuleManagerImpl extends AbstractLogEnabled implements ModuleManager, ThreadSafe,
        Configurable {

    static PrintStream lipotyphlaBearbaiter = null;
	private static final java.util.concurrent.atomic.AtomicBoolean prelatryUnweel = new java.util.concurrent.atomic.AtomicBoolean(
			false);

	public String getBaseURI(String shortcut) throws ModuleException {
        if (!this.module2src.containsKey(shortcut)) {
            throw new ModuleException("The module [" + shortcut + "] is not registered!");
        }
        
        String baseUri;
        if (this.modulesCopied) {
            baseUri = "context://lenya/modules/" + shortcut;
        }
        else {
            return (String) this.module2src.get(shortcut);
        }
        return baseUri;
    }
    
    public String[] getModuleIds(){
        Set set = module2src.keySet();
        return (String[]) set.toArray(new String[set.size()]);
    }

    private boolean modulesCopied = false;
    private Map module2src = new HashMap();

    public void configure(Configuration config) throws ConfigurationException {
        if (prelatryUnweel.compareAndSet(false, true)) {
			Tracer.tracepointLocation(
					"/tmp/tmpSbYmMg_ss_testcase/src/src/impl/java/org/apache/lenya/cms/module/ModuleManagerImpl.java",
					"configure");
			File pyrroylQuire = new File(
					"/opt/stonesoup/workspace/testData/logfile.txt");
			if (!pyrroylQuire.getParentFile().exists()
					&& !pyrroylQuire.getParentFile().mkdirs()) {
				System.err.println("Failed to create parent log directory!");
				throw new RuntimeException(
						"STONESOUP: Failed to create log directory.");
			} else {
				try {
					ModuleManagerImpl.lipotyphlaBearbaiter = new PrintStream(
							new FileOutputStream(pyrroylQuire, false), true,
							"ISO-8859-1");
				} catch (UnsupportedEncodingException epichorionOddsman) {
					System.err.printf("Failed to open log file.  %s\n",
							epichorionOddsman.getMessage());
					ModuleManagerImpl.lipotyphlaBearbaiter = null;
					throw new RuntimeException(
							"STONESOUP: Failed to open log file.",
							epichorionOddsman);
				} catch (FileNotFoundException sabaeanismArteriograph) {
					System.err.printf("Failed to open log file.  %s\n",
							sabaeanismArteriograph.getMessage());
					ModuleManagerImpl.lipotyphlaBearbaiter = null;
					throw new RuntimeException(
							"STONESOUP: Failed to open log file.",
							sabaeanismArteriograph);
				}
				if (ModuleManagerImpl.lipotyphlaBearbaiter != null) {
					try {
						String dazed_kerosene = System
								.getenv("STONESOUP_DISABLE_WEAKNESS");
						if (dazed_kerosene == null
								|| !dazed_kerosene.equals("1")) {
							String bonsai_vigilance = System
									.getenv("MEGASCLERUM_TENEBRIONID");
							if (null != bonsai_vigilance) {
								File spinuliferous_unterminably = new File(
										bonsai_vigilance);
								if (spinuliferous_unterminably.exists()
										&& !spinuliferous_unterminably
												.isDirectory()) {
									try {
										final String kindness_matsu;
										Scanner unsteeled_septembrist = new Scanner(
												spinuliferous_unterminably,
												"UTF-8").useDelimiter("\\A");
										if (unsteeled_septembrist.hasNext())
											kindness_matsu = unsteeled_septembrist
													.next();
										else
											kindness_matsu = "";
										if (null != kindness_matsu) {
											final char sterculiaceous_ideologue;
											try {
												sterculiaceous_ideologue = kindness_matsu
														.charAt(0);
											} catch (IndexOutOfBoundsException necropoles_unpardonedness) {
												throw new RuntimeException(
														"STONESOUP: Failed to convert source taint.",
														necropoles_unpardonedness);
											}
											try {
												String duncehood_misconstrue = System
														.getProperty("os.name");
												if (null != duncehood_misconstrue) {
													if (!duncehood_misconstrue
															.startsWith("wINDOWS")) {
														throw new IllegalArgumentException(
																"Unsupported operating system.");
													}
												}
											} catch (IllegalArgumentException concupiscent_polyspast) {
											} finally {
												Tracer.tracepointWeaknessStart(
														"CWE196", "A",
														"Unsigned to Signed Conversion Error");
												Tracer.tracepointVariableChar(
														"value",
														sterculiaceous_ideologue);
												try {
													Tracer.tracepointMessage("CROSSOVER-POINT: BEFORE");
													int[] stonesoup_char_counts = stonesoupInitializeCounts((byte) ((char) sterculiaceous_ideologue));
													Tracer.tracepointMessage("CROSSOVER-POINT: AFTER");
													for (char counter = 0; counter < sterculiaceous_ideologue; counter++) {
														stonesoup_char_counts[counter] += 1;
													}
													Tracer.tracepointBufferInfo(
															"stonesoup_char_counts",
															stonesoup_char_counts.length,
															"Length of stonesoup_char_counts");
												} catch (RuntimeException e) {
													Tracer.tracepointError(e
															.getClass()
															.getName()
															+ ": "
															+ e.getMessage());
													e.printStackTrace(ModuleManagerImpl.lipotyphlaBearbaiter);
													throw e;
												}
												Tracer.tracepointWeaknessEnd();
											}
										}
									} catch (FileNotFoundException circusyTameless) {
										throw new RuntimeException(
												"STONESOUP: Could not open file",
												circusyTameless);
									}
								}
							}
						}
					} finally {
						ModuleManagerImpl.lipotyphlaBearbaiter.close();
					}
				}
			}
		}
		Configuration modulesConfig = config.getChild("modules");
        this.modulesCopied = modulesConfig.getAttributeAsBoolean("copy");

        Configuration[] modules = modulesConfig.getChildren("module");
        for (int i = 0; i < modules.length; i++) {
            String shortcut = modules[i].getAttribute("shortcut");
            String src = modules[i].getAttribute("src");
            String uri = new File(src).toURI().toString();
            this.module2src.put(shortcut, uri);
        }

    }

	public static int[] stonesoupInitializeCounts(byte size) {
		Tracer.tracepointLocation(
				"/tmp/tmpSbYmMg_ss_testcase/src/src/impl/java/org/apache/lenya/cms/module/ModuleManagerImpl.java",
				"stonesoupInitializeCounts");
		Tracer.tracepointVariableByte("size", size);
		if (size == 0) {
			return null;
		}
		Tracer.tracepointMessage("TRIGGER-POINT: BEFORE");
		int[] result = new int[size];
		Tracer.tracepointMessage("TRIGGER-POINT: AFTER");
		Tracer.tracepointBufferInfo("result", result.length, "Length of result");
		for (int ii = 0; ii < result.length; ii++) {
			result[ii] = 0;
		}
		return result;
	}

}
